<?php

/**
 * @file
 * Contains \Drupal\blackbaud_sky_api\Form\BlackbaudSkyApiAuthorizeForm.
 */

namespace Drupal\blackbaud_sky_api\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Render\Element;
use Drupal\blackbaud_sky_api\BlackbaudOauth;
use Drupal\blackbaud_sky_api\BlackbaudAPI;

class BlackbaudSkyApiAuthorizeForm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'blackbaud_sky_api_authorize_form';
  }

  public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state) {
    // Check both methods to make sure we have auth.
    /**
     * @todo DI the config to the form.
     */
    $token = \Drupal::config('blackbaud_sky_api.settings')->get('blackbaud_sky_api_access_token');

    // If we have a token.
    if (!empty($token)) {
      $bb = new BlackbaudAPI();
      $api = $bb->checkToken();
    }

    // Show the submit or not.
    if (empty($token) || !$api) {
      // We are not Authorized, instruct the people.
      $form['title'] = [
        '#type' => 'item',
        '#markup' => '<center><h3>Blackbaud is not authorized on this site.  Click Authorize below and follow the prompts.<h3></center>',
      ];

      $form['submit'] = [
        '#type' => 'submit',
        '#value' => t('Authorize'),
        '#prefix' => '<center>',
        '#suffix' => '</center>',
      ];
    }
    else {
      // We are good!
      $form['title'] = [
        '#type' => 'item',
        '#markup' => '<center><h3>Blackbaud is authorized, you may carry on.<h3></center>',
      ];
    }

    return $form;
  }

  public function validateForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {
    // Instantiate the BlackBaud request and grab the code.
    $bb = new BlackbaudOauth();
    $bb->getCode();
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {}
}
